<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2005 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

/*********************************************************************************/
/* Function: navPage
/* Role: echos a navigation to change pages
/* Parameters:
/*   - $url: the first part of the URL
/*   - $npages: number of pages
/*   - $page: current page
/* Output:
/*   - the navigation
/* Create: 09/2005
/*********************************************************************************/
function navPage($url, $npages, $page) {
	$str = "";
	for ($i=1;$i<=min(4,$npages);$i++) {
		if ($page == $i) {
			$str .= "<strong>$i</strong> ";
		} else {
			$str .= "<a href=\"${url}$i\" class=\"basic\">$i</a> ";
		}
	}
	if ($page > 9) $str .= " ... ";
	for ($i=max(5,$page-4);$i<=min($npages,$page+4);$i++) {
		if ($page == $i) {
			$str .= "<strong>$i</strong> ";
		} else {
			$str .= "<a href=\"${url}$i\" class=\"basic\">$i</a> ";
		}
	}
	if ($page < $npages -8) $str .= " ... ";
	for ($i=max(($npages-3),$page+5);$i<=$npages;$i++) {
		if ($page == $i) {
			$str .= "<strong>$i</strong> ";
		} else {
			$str .= "<a href=\"${url}$i\" class=\"basic\">$i</a> ";
		}
	}
	return $str;
}

/*********************************************************************************/
/* Function: getmicrotime
/* Role: time with milliseconds
/* Parameters:
/* Output:
/*   - returns the time
/* Source: php website
/*********************************************************************************/
 if (!function_exists('getmicrotime')) {
	function getmicrotime()  {
		global $DEBUG;
		list($usec, $sec) = explode(" ", microtime());
		return ((float)$usec + (float)$sec); 
	}
}
/*********************************************************************************/
/* Function: cleanURL
/* Role: cleans up URL's so we pass the W3C test. Mostly: replace & with $amp;
/* Parameters: 
/*   - $var: the URL to clean
/* Output:
/*   - the URL
/*********************************************************************************/
function cleanURL ($var) {
	$var=preg_replace("/&/","&amp;",$var);
	$var=preg_replace("/&amp;amp;/","&amp;",$var);
	return $var;
}

/*********************************************************************************/
/* Function: shorten
/* Role: Shorten a string 
/* Parameters: 
/*   - $var: the string to shorten
/*   - $len: number of characters
/* Output:
/*   - the shorten string
/* Source: php website
/*********************************************************************************/
function shorten ($var, $len = 30) {
  if (empty ($var)) {
    return "";
  }
  if (strlen ($var) < $len) {
    return $var;
  } 
  // if (preg_match ("/(.{1,$len})\s/", $var, $match)) {
  //  return $match [1];
  //}
  //else {
  return substr ($var, 0, $len);
    //}
}


/*********************************************************************************/
/* Function: shortenURL
/* Role: Shorten a string, add spaces before dots, and add dots if it did shorten 
/* Parameters: 
/*   - $var: the string to shorten
/*   - $len: number of characters
/* Output:
/*   - the shorten string
/*********************************************************************************/
function shortenURL ($var, $len = 30) {
  $varS = shorten($var, $len);
  if ($varS != $var) { 
    $varS = str_replace(".", " .", $varS);
    $varS .= "...";
  } else {
    $varS = str_replace(".", " .", $varS);
  }
  return $varS;
}

/*********************************************************************************/
/* Function: shortenPage
/* Role: Shorten a page, and add dots if it did shorten 
/* Parameters: 
/*   - $var: the string to shorten
/*   - $len: number of characters
/* Output:
/*   - the shorten string
/*********************************************************************************/
function shortenPage ($var, $len = 30) {
  $varS = shorten($var,$len);
  if ($varS != $var) { 
    $varS .= "...";
  }
  return $varS;
}

/*********************************************************************************/
/* Function: shortencenter
/* Role: Shorten a string from the center (remove chars at the center)
/* Parameters: 
/*   - $var: the string to shorten
/*   - $len: number of characters
/* Output:
/*   - the shorten string
/* Created: 06/2004
/*********************************************************************************/
function shortencenter ($var, $len = 30) {
  if (empty ($var)) {
    return "";
  }
  if (strlen ($var) < $len) {
    return $var;
  }
  $len = floor($len/2)-1;
  return  substr($var,0,$len)."..".substr ($var,strlen($var)-$len,$len);
}

/*********************************************************************************/
/* Function: nToday
/* Role: number of access to a site today
/* Parameters:
/*   - $c: connection to database
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - number of access
/* Created: 06/2004
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function nToday($c,$table, $site) {
  $today = date("Y-m-d");
  $thismonth = date("Y-m-01");
  // get total access today WHERE date='$today'
  $req = "SELECT SUM(count) as count FROM ${table}_acces WHERE date='$today';";
  $res = mysql_query($req,$c);
  $count=mysql_fetch_array($res);
  if ($count['count'] == "") {
    $c = 0;
  } else {
    $c = $count['count'];
  }
  return $c;
}

/*********************************************************************************/
/* Function: firstDay
/* Role: first day recorded
/* Parameters:
/*   - $c: connection to database
/*   - $table: base name for sql tables
/* Output:
/*   - the first day, Y-m-d
/* Created: 02/2005
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function firstDay($c,$table) {
  $req = "SELECT date FROM ${table}_acces ORDER BY date ASC LIMIT 0,1;";
  $res = mysql_query($req,$c);
  $first=mysql_fetch_object($res);
  return $first->date;
}

/*********************************************************************************/
/* Function: lastDay
/* Role: last day recorded
/* Parameters:
/*   - $c: connection to database
/*   - $table: base name for sql tables
/* Output:
/*   - the last day, Y-m-d
/* Created: 02/2005
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function lastDay($c,$table) {
  $req = "SELECT date FROM ${table}_acces ORDER BY date DESC LIMIT 0,1;";
  $res = mysql_query($req,$c);
  $first=mysql_fetch_object($res);
  return $first->date;
}

/*********************************************************************************/
/* Function: nThisMonth
/* Role: number of access to a site this month
/* Parameters:
/*   - $c: connection to database
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - number of access
/* Created: 06/2004
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function nThisMonth($c,$table, $site) {
$today = date("Y-m-d");
$thismonth = date("Y-m-01");
$req = "SELECT SUM(count) as count FROM ${table}_acces WHERE date>='$thismonth' AND date<='$today';";
$res = mysql_query($req,$c);
$count=mysql_fetch_array($res);
if ($count['count'] == "") {
	$c = 0;
} else {
	$c = $count['count'];
}
return $c;
}

/*********************************************************************************/
/* Function: nTotal
/* Role: total number of access to a site
/* Parameters:
/*   - $c: connection to database
/*   - $table: base name for sql tables
/*   - $site: root of the website
/* Output:
/*   - number of access
/* Created: 02/2005
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function nTotal($c,$table, $site) {
  $req = "SELECT SUM(count) as count FROM ${table}_acces;";
  $res = mysql_query($req,$c);
  $count=mysql_fetch_array($res);
  if ($count['count'] == "") {
    $c = 0;
  } else {
    $c = $count['count'];
  }
  return $c;
}

/*********************************************************************************/
/* Function: dropSQLStructure
/* Role: drops the SQL structures of a group of tables, used in the application design...
/* Parameters:
/*   - $c: connection to database
/*   - $table: base name for sql tables
/* Output:
/*   -
/* Created: 06/2004
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function dropSQLStructure($c,$table) {
$tables[] = $table."_pages";
$tables[] = $table."_acces";
$tables[] = $table."_host";
$tables[] = $table."_country";
$tables[] = $table."_hour";
$tables[] = $table."_day";
$tables[] = $table."_os";
$tables[] = $table."_browser";
$tables[] = $table."_keyword";
$tables[] = $table."_referrer";
$tables[] = $table."_retention";
foreach ($tables as $thetable) {
	$sql = "show create table $thetable";
	$describe=mysql_query($sql,$c);
	while ($ligne=mysql_fetch_array($describe)){
		//echo "<br>$ligne";
		$str = str_replace("$table", "\${table}", $ligne[1]);
		echo "<br>$str;<br>";
	}
}
}

/*********************************************************************************/
/* Function: diskUsage
/* Role: drops the detailed disk usage
/* Parameters: 
/*   - $c: connection to database
/* Output:
/* Created: 06/2004
/* Modified 03/2005 because of new format of array "sites"
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function diskUsage ($c) {
global $sites;
echo "<table class='simple'>
<tr><td class='title' colspan='3'>Existing databases</td></tr>
<tr><td class='caption'>Domain</td><td class='caption'>Table</td><td class='caption'>Disk usage</td></tr>";
while ($bar=each($sites)) {
	$id = $bar[0];
	$table = $bar[1][table];
	$site = $bar[1][site];
	echo "<tr><td>$site</td><td>$table</td><td>";
	$tables[] = $table."_pages";
	$tables[] = $table."_acces";
	$tables[] = $table."_host";
	$tables[] = $table."_country";
	$tables[] = $table."_hour";
	$tables[] = $table."_day";
	$tables[] = $table."_os";
	$tables[] = $table."_browser";
	$tables[] = $table."_keyword";
	$tables[] = $table."_referrer";
	$tables[] = $table."_retention";
	foreach ($tables as $thetable) {
		// Get size of table
		$result = mysql_query ("show table status like '$thetable'",$c);
		$row = mysql_fetch_array($result);
		$number_line = $row['Rows'];      // Get number of lines in tables
		$table_size = number_format(($row['Data_length'] + $row['Index_length'])/1024,1);
		echo "$thetable: $number_line rows, $table_size kb<br>";
	}
	echo "</td></tr>";
	unset($tables);
}
echo "</table>";
}

/*********************************************************************************/
/* Function: diskUsageTable
/* Role: returns the total disk usage for a set of tables
/* Parameters: 
/*   - $c: connection to database
/*  - $table: table root
/* Output:
*   - disk usage in kb
/* Created: 06/2004
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function diskUsageTable ($c,$table) {
$tables[] = $table."_pages";
$tables[] = $table."_acces";
$tables[] = $table."_host";
$tables[] = $table."_country";
$tables[] = $table."_hour";
$tables[] = $table."_day";
$tables[] = $table."_os";
$tables[] = $table."_browser";
$tables[] = $table."_keyword";
$tables[] = $table."_referrer";
$tables[] = $table."_retention";
$table_size = 0;
foreach ($tables as $thetable) {
	// Get size of table
	$result = mysql_query ("show table status like '$thetable'",$c);
	$row = mysql_fetch_array($result);
	// $number_line = $row['Rows'];      // Get number of lines in tables
	$table_size += ($row['Data_length'] + $row['Index_length'])/1024;
}
$table_size = number_format($table_size,1);
return $table_size;
}

/*********************************************************************************/
/* Function: clearDB
/* Role: delete content of log tables (WATCH OUT, IT REALLY CLEARS IT ALL!!!)
/* Parameters: 
/*   - $c: connection to database
/*   - $table: base name for tables
/* Output: none
/* Created 05/2004
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function clearDB($c,$table) {
global $config_table;
// pages
$table_p = $table."_pages";
// acces
$table_a = $table."_acces";
// hosts
$table_host = $table."_host";
// country
$table_c = $table."_country";
// hour
$table_hour = $table."_hour";
// day
$table_day = $table."_day";
// os
$table_os = $table."_os";
// browser
$table_b = $table."_browser";
// keywords
$table_k = $table."_keyword";
// referrer
$table_r = $table."_referrer";
// retention
$table_ret = $table."_retention";
// Clear up tables
$sql= "TRUNCATE TABLE `$table_a`";
echo "<br>Clearing up $table_a";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_host`";
echo "<br>Clearing up $table_host";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_c`";
echo "<br>Clearing up $table_c";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_os`";
echo "<br>Clearing up $table_os";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_b`";
echo "<br>Clearing up $table_b";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_k`";
echo "<br>Clearing up $table_k";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_r`";
echo "<br>Clearing up $table_r";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_ret`";
echo "<br>Clearing up $table_ret";
$res = mysql_query($sql,$c);
$sql= "TRUNCATE TABLE `$table_p`";
echo "<br>Clearing up $table_p";  
$res = mysql_query($sql,$c);
$sql = "UPDATE `$table_hour` SET count=0";
echo "<br>Clearing up $table_hour";
$res = mysql_query($sql,$c);
$sql = "UPDATE `$table_day` SET count=0";
echo "<br>Clearing up $table_day";
$res = mysql_query($sql,$c);
}

/*********************************************************************************/
/* Function: deleteDB
/* Role: delete log tables (WATCH OUT, IT REALLY CLEARS IT ALL!!!)
/* Parameters: 
/*   - $c: connection to database
/*   - $table: base name for tables
/* Output: none
/* Created 06/2004
/* Modified 03/2005 because of new format of array "sites"
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/
function deleteDB($c,$table) {
global $sites;
// Clear the tables
clearDB($table);
// Delete the tables
$tables[] = $table."_pages";
$tables[] = $table."_acces";
$tables[] = $table."_host";
$tables[] = $table."_country";
$tables[] = $table."_hour";
$tables[] = $table."_day";
$tables[] = $table."_os";
$tables[] = $table."_browser";
$tables[] = $table."_keyword";
$tables[] = $table."_referrer";
$tables[] = $table."_retention";
foreach ($tables as $thisone) {
	$sql= "DROP TABLE `$thisone`";
	echo "<br>Deleting table $thisone";
	$res = mysql_query($sql,$c);
}
// Remove line from configuration
$temp = fopen ("./Php/sites.php", 'w');
fwrite($temp, "<?\n
// Sites beging audited
\$vsite = 1.1;
\$sites = array( ");
$i = 0;
while ($bar=each($sites)) {
	$thisid = $bar[0];
	$thistable = $bar[1][table];
	$thissite = $bar[1][site];
	$thispublic = $bar[1][public];
	$thistrim = $bar[1][trim];
	if ($thistable != $table) {
		if ($i==0) {
			fwrite($temp, "\n\"$thisid\"=> array(\"table\" =>\"$thistable\", \"site\"=>\"$thissite\", \"public\"=>$thispublic, \"trim\"=>$thistrim)");
		}  else {
			fwrite($temp, "\n,\"$thisid\"=> array(\"table\" =>\"$thistable\", \"site\"=>\"$thissite\", \"public\"=>$thispublic, \"trim\"=>$thistrim)");
		}
		$i+=1;
	}
}
fwrite($temp, ");\n?>");
fclose($temp);
}

/*********************************************************************************/
/* Function: getTimeEn
/* Role: returns a time interval in a more readable format
/* Parameters: 
/*   - $originalDate: time to convert
/* Output: the duration, in english
/* Created 09/2005. Inspired strongly by the php website
/*********************************************************************************/
function getTimeEn($elapsedTime, $roundTo=0) {
    
    if($elapsedTime==1) {
        // One second
        $elapsedString = $elapsedTime . " second";
    } else if($elapsedTime<(60*2)) {
        // Seconds
        $elapsedString = $elapsedTime . " seconds";
    } else if($elapsedTime<(60*60*2)) {
        // Minutes
        $elapsedString = round($elapsedTime/60, $roundTo) . " minutes";
    } else if($elapsedTime<(60*60*24*2)) {
        // Hours
        $elapsedString = round($elapsedTime/60/60, $roundTo) . " hours";
    } else if($elapsedTime<(60*60*24*7*2)) {
        // Days
        $elapsedString = round($elapsedTime/60/60/24, $roundTo) . " days";
    } else if($elapsedTime<(60*60*24*30*2)) {
        // Weeks
        $elapsedString = round($elapsedTime/60/60/24/7, $roundTo) . " weeks";
    } else if($elapsedTime<(60*60*24*365*2)) {
        // Months
        $elapsedString = round($elapsedTime/60/60/24/12, $roundTo) . " months";
    } else {
        // Years
        $elapsedString = round($elapsedTime/60/60/24/365, $roundTo) . " years";
    }
    
    return $elapsedString;
 }
 
/*********************************************************************************/
/* Function: ls
/* ls(dir,pattern) return file list in "dir" folder matching "pattern"
/* ls("path","module.php?") search into "path" folder for module.php3, module.php4, ...
/* ls("images/","*.jpg") search into "images" folder for JPG images
/* Created: 09/2005
/* Source: php website
/*********************************************************************************/
 
function ls($__dir="./",$__pattern="*.*") {
  settype($__dir,"string");
  settype($__pattern,"string");
  $__ls=array();
  $__regexp=preg_quote($__pattern,"/");
  $__regexp=preg_replace("/[\\x5C][\x2A]/",".*",$__regexp);
  $__regexp=preg_replace("/[\\x5C][\x3F]/",".", $__regexp);
  if(is_dir($__dir))
   if(($__dir_h=@opendir($__dir))!==FALSE) {
    while(($__file=readdir($__dir_h))!==FALSE)
    if(preg_match("/^".$__regexp."$/",$__file))
      array_push($__ls,$__file);
 
    closedir($__dir_h);
    sort($__ls,SORT_STRING);
   }
  return $__ls;
 } 
 
/*********************************************************************************/
/* Function: tmpClean
/* Role: removes all files from tmp directory
/* Parameters:
/*   - how long to keep the files (in seconds)
/* Output:
/* Created: 09/2005
/*********************************************************************************/
function tmpClean($limit = 300)  {
	$limit = time()-$limit;
	$dir = "./tmp";
	$list = ls($dir,'tmp*.txt.php');
	foreach ($list as $file) { 
		$pos = strpos ($file,".");
		$time = substr($file, $pos+1);
		$pos = strpos ($time,".");
		$time = substr($time, 0,$pos);
		if (($time>1000)&&($time<$limit)) {
			unlink("$dir/".$file);
		}
	}
}

/*********************************************************************************/
/* Function: setcachepagename
/* Role: sets a gobal variable with cachepagename[pageid] = page name
/* Parameters:
/*   - $c: connection to the database
/*   - $table
/* Output:
/*   - 
/* Created: 09/2005
/*********************************************************************************/
function setcachepagename($c,$table)  {
global $cachepagenames, $cachepagenamesset;
if (!$cachepagenamesset) {
	$cachepagenames = array();
	$sql = "SELECT id,name FROM ${table}_pages ORDER BY name ASC";
	$res = mysql_query($sql,$c);
	while($row = mysql_fetch_object($res)) {
		$cachepagenames[$row->id] = $row->name;
	}
	$cachepagenamesset = true;
}
}

/*********************************************************************************/
/* Function: pagename
/* Role: returns the name of a page, based on it's id
/* Parameters:
/*   - $c: connection to the database
/*   - $table
/*   - $pageid
/* Output:
/*   - pagename
/* Created: 09/2005
/*********************************************************************************/
function pagename($c,$table,$pageid)  {
global $cachepagenames, $cachepagenamesset;
if (!$cachepagenamesset) setcachepagename($c,$table);
return $cachepagenames[$pageid];
}


/*********************************************************************************/
/* Function: formnavpages
/* Role: returns a navigation form to choose a page or the whole site
/* Parameters:
/*   - $c: connection to the database
/*   - $table
/*   - $showpage: the selected page
/*   - $url: the url to call in the form
/*   - $title: title to put in front of the form
/*   - $includeall: if true, 'all pages' is a possible choice
/* Output:
/*   - a string with the form
/* Created: 09/2005
/*********************************************************************************/
function formnavpages($c,$table,$showpage,$url,$title, $includeall=true)  {
global $cachepagenames, $cachepagenamesset;
if (!$cachepagenamesset) setcachepagename($c,$table);
$str = "<div align=\"center\"><form name=\"pageselect\" action=\"$url\" method=\"post\"><table class=\"form\">
<tr><td valign=\"middle\" width=\"150px\">$title</td>
<td valign=\"middle\" width=\"200px\"><SELECT NAME=\"pageid\">";
if ($includeall) {
	if ($showpage=='all') {
		$str .= "<option value=\"all\" selected>all pages</option>";
	} else {
		$str .= "<option value=\"all\">all pages</option>";
	}
}
foreach ($cachepagenames as $thispageid=>$pagename) {
	$thispagename = shortenPage($pagename,40);
	if ($showpage==$thispageid) {
		$str .= "<option value=$thispageid selected>$thispagename</option>";
	} else {
		$str .= "<option value=$thispageid>$thispagename</option>";
	}
}
$str .= "</select></td>
<td valign=\"middle\" width=\"50px\"><input type=\"submit\" value=\"Fetch\"></td>
</tr></table></form>\n</div>\n";
return $str;
}

/*********************************************************************************/
/* Function: create_db
/* Role: creates tables in database to track a new site
/* Parameters:
/*   - $c: connection to the database
/*   - $table
/* Output:
/* Created: 2004
/* Changed (pulled out connection to db): 10/2005
/*********************************************************************************/

function create_db($c,$table) {
echo "<br>Creating log tables:";
echo "<ul>
<li>${table}_acces </li>
<li>${table}_browser</li>
<li>${table}_country</li>
<li>${table}_host</li>
<li>${table}_keyword</li>
<li>${table}_os</li>
<li>${table}_pages</li>
<li>${table}_day</li>
<li>${table}_hour</li>
<li>${table}_retention</li>
</ul>";

include ("./Php/sqlTables.sql.php");
$sqllist = split("\n", $sql);
foreach($sqllist as $doit) {
	if (!mysql_query($doit,$c)) 
		die($msgSqlQuerryError."<br>Error with database. <br>Was working on $doit.");
}
echo "<br>Done with creation of tables for $table.";
}

?>
