<?
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2005 ZoneO-soft, S. Merkel (dude@zoneo.net)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/

if (!isset($file) or $file=="") {$file = $_GET['file'];}
include("./Php/phplot.php");
include("./tmp/".$file);

function hex2rgb($hex) {
   $color = str_replace('#','',$hex);
   $rgb = array(hexdec(substr($color,0,2)),
                hexdec(substr($color,2,2)),
                hexdec(substr($color,4,2)));
   return $rgb;
 } 

if (!isset($notime)) {
	$notime=FALSE;
}
if (!isset($yscale)) {
	$yscale=FALSE;
}

$dark = hex2rgb("#122C4D");

$graph = new PHPlot($width,$height);
$graph->SetGridColor($dark);
$graph->SetLightGridColor($dark);
$graph->SetFont("x_label",2);
$graph->SetFont("y_label",2);
$graph->SetDataType("data-data");  //Must be called before SetDataValues
if (!$notime) {
	$graph->SetXGridLabelType("time");
	$graph->SetXTimeFormat("%b %y");
}
if ($yscale=='sqrt') {
	// $graph->setYGridLabelType("sqrt");
	$graph->SetYScaleType("sqrt");
	$tickStep = max(intval(sqrt($maxY)/6),1);
} elseif ($yscale=="cbrt") {
	//$graph->setYGridLabelType("sqrt");
	$graph->SetYScaleType("cbrt");
	$tickStep = max(intval(pow($maxY,1./3)/6),1); 
} elseif ($yscale=="qdrt") {
	//$graph->setYGridLabelType("sqrt");
	$graph->SetYScaleType("qdrt");
	$tickStep = max(intval(pow($maxY,1./4)/6),1); 
} else {
	$pow = intval(log($maxY,10));
	if ($maxY<2*pow(10,$pow)) {
		$tickStep = 2*pow(10,$pow-1);
	} else if ($maxY<5*pow(10,$pow)) {
		$tickStep = 5*pow(10,$pow-1);
	} else {
		$tickStep = pow(10,$pow);
	}
}
//echo "MaxY is $maxY, pow is $pow and tickStep is $tickStep";
$graph->SetVertTickIncrement($tickStep);
$graph->SetXDataLabelAngle(90);
if (isset($xlabel)) { $graph->SetXLabel($xlabel); } else { $graph->SetXLabel("");}
if (isset($ylabel)) { $graph->SetYLabel($ylabel); } else { $graph->SetYLabel("");}
$graph->SetDataValues($date_data);
$graph->SetColor($dark);
if (!$notime) {
	// If data more than 1.5 years, ticks every 2 months
	if (($end-$start) > (18*2679000)) {
	  $graph->SetHorizTickIncrement(2*2679000);
	// data for more than three month, monthly ticks in X
	} else if (($end-$start) > (3*2679000)) {
	  $graph->SetHorizTickIncrement(2679000);
	// if data for more than two week, weekly ticks in X
	} elseif  (($end-$start) > (2*604800)) {
	  $graph->SetHorizTickIncrement(604800);
	  $graph->SetXTimeFormat("%e %b") ;
	} else {
	  $graph->SetHorizTickIncrement(86400);
	  $graph->SetXTimeFormat("%a %e") ;
	}
} else {
	$incr = intval(($end-$start)/15);
	if ($incr<1) $incr=1;
	$graph->SetHorizTickIncrement($incr);
}
// Making space for the legend (I can't find the option)
if (isset($legende)) {
	if (($end-$start) > (8*2679000)) { // 15 months
		$end += 5*2679000;
	} else if (($end-$start) > (8*2679000)) { // 8 months
		$end += 3*2679000;
	} elseif (($end-$start) > (3*2679000)) { // 3 months
		$end +=2679000;
	} elseif  (($end-$start) > (2*604800)) { // 2 weeks
		$end +=2*604800;
	} else {
		$end +=86400*2;
	}
}
$graph->SetPlotType("$plottype");
$graph->SetDrawXDataLabels(false);
$graph->SetPlotAreaWorld($start,0,$end,$maxY);
$graph->SetDataColors( array( "red","blue","green","orange","violet", "black","peru", "aquamarine1","DarkGreen"), array( "black","black", "black", "black", "black", "black","black","black","black") );
// $graph->SetLegendPixel(500,0,"");
$graph->SetLineStyles('solid');
if (isset($legende)) {
  $graph->SetLegend($legende);
  //$graph->SetLegendWorld($end, $maxYY);
}
$graph->SetLineWidth(2);
// Setting the image format
if (function_exists("imagepng")) {
	$graph->SetFileFormat('png');
} elseif (function_exists("imagegif")) {
	$graph->SetFileFormat('gif');
} elseif (function_exists("imagejpeg")) {
	$graph->SetFileFormat('jpg');
}  elseif (function_exists("imagewbmp")) {
	$graph->SetFileFormat('wbmp');
} else {
	die("No image support in this PHP server");
}
$graph->DrawGraph();
?>
